
package assn2;

public class Main {
  public static void main (String[] args) {
    // +--- Abstraction, "List" is the type of variable (object) "lst"
    // |
    // v
    // List lst = new LinkedList();
    //               ^
    //               |
    //               +--- an implementation of the abstraction
    //                    a class that implements the interface
 
    List lst = new ArrayList(8);

    // compiler will make sure the lst obj is only asked to run methods
    // that appear in the List interface, no matter what other
    // methods might appear in the implementation class LinkedList
     
    // for example, the LinkedList implementation might have fields,
    // methods, etc that are specific to manipulation links (pointers
    // to cell/node objects, but that is internal implementation info 
    // and should not be assumed or used in main where the List object 
    // is created and used
     
    // similarly the ArrayList implementation class might have fields
    // that are for bookkeeping array index information to access elements
    // stored in an array... and since those are implementation details
    // specific to Array use for a list, the List abstraction object in main
    // should have no access or information about the array or its indices

    //lst.sayFoo();
    System.out.println(lst);

    Tester tst = new Tester(); // organize and systemetize your testing...
                               // just a suggestion, test how you want to
                                 
    /* Sample testing code is provided below for you to examine */

    tst.insRemErr(lst);
/*
    tst.ins(lst); // tester object runs test of the ins op
    tst.rem(lst); // tester runs tests of the rem op
    tst.get(lst); // etc.
    tst.find(lst);
    tst.isEmpty(lst);
    tst.size(lst);
    tst.clear(lst);
*/   
    // this doesnt make testing easier, it makes it more 
    // organized, and also easier to comment in and comment out
    // large chunks of testing
      
  }
}
