// public interface Node {
//	  double getValue();
//	  void setValue(double value);
//	  Node getNext();
//	  void setNext(Node next);
//   boolean hasNext();
// }

// an implementation class has to provide AT LEAST the methods
// given in the interface for the abstraction it's implementing
// it can (if needed, or just because) have other methods as well
// a variable object declared to be of the abstraction type cannot call
// the extra methods that might be in the implementation class

package assn2;

public class NodeImpl implements Node {
//                                ^^ the abstraction interface
//             ^^ the implementation class
   private double _value;
	private Node _next;
	
	public NodeImpl(double val, Node nxt) {
		_value = val;
		_next = nxt;
	}
	
   // we provide this Node interface implementation... dont change it
   public boolean hasNext() { return(this._next!=null); } 

	@Override
	public double getValue() { return this._value;	}

	@Override
	public void setValue(double value) { this._value = value;}

	@Override
	public Node getNext() { return this._next; }

	@Override
	public void setNext(Node next) { this._next = next; }
}

