
package assn2;

public class Tester {
   // in this class we write a public void methods that will test operations
   // in the List class implementation we are writing
   // the tests are at the abstract level, meaning we are
   // creating situations that see if the state of the List is 
   // changing properly when the operations are run.
   
   // this means we are not looking into the implementation details
   // in ArrayList, or LinkedList
   
   // it also means we can create one set of tests...
   // and the tests will work the same way whether we
   // pass in a List that is Array implemented, or a List that is
   // Links implemented... the implementation should not matter
   // and the tests turning out the same for both implementations
   // prove the abstraction
   
   public void insRemErr ( List ls ) {
      System.out.println("== Test of ins error ==========");
      //ls.clear();
      //System.out.println("MAX: "+ls.MAX()+", size: "+ls.size());
      ls.ins(0,110.0);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(1,111.1);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(2,112.2);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(3,113.3);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(4,114.4); System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(5,115.5); System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(0,9.09); System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(0,9.19); System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(0,9.29); System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(0,9.39); System.out.print("("+ls.size()+") "); System.out.println(ls);
      //ls.ins(ls.MAX(),1.1111);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(ls.size(),1.1111);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(ls.size()-1,1.1111);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.rem(0);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(ls.size()-1,1.1111);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.rem(0);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.ins(ls.size(),2.2222);System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.rem(ls.size());System.out.print("("+ls.size()+") "); System.out.println(ls);
      ls.rem(ls.size()-1);System.out.print("("+ls.size()+") "); System.out.println(ls);
   }
   
   public void ins ( List ls ) { // note we are passing in a List
                                 // not an ArrayList, not a LinkedList
                                 // so this means all tests must be done using
                                 // methods in the List interface
      System.out.println("== Test of ins op ==========");
      ls.clear();
      System.out.println(ls.ins(0,10.0)); 
      System.out.println(ls);
      ls.ins(0,11.1); ls.ins(1,12.2);
      System.out.println(ls);
      System.out.println(ls.ins(14,111.1));
      System.out.println(ls.ins(3,101.01));
      System.out.println(ls); 
      return;
   }
   
   public void rem (List ls) {
     System.out.println("== Test of rem op ==========");
     ls.clear();
     System.out.println(ls.rem(0)); 
     System.out.println(ls);
     ls.ins(0,11.1); ls.ins(1,12.2); ls.ins(2,13.3);
     System.out.println(ls);
     System.out.println(ls.rem(0));
     System.out.println(ls.rem(1));
     System.out.println(ls); 
     System.out.println(ls.size());
     ls.ins(0,14.4); ls.ins(1,17.7);
     System.out.println(ls);
     System.out.println(ls.rem(1));
     System.out.println(ls); 
     System.out.println(ls.rem(100));
     System.out.println(ls);
     return;
   }
   
   public void get (List ls) {
     System.out.println("== Test of get op ==========");
     ls.clear();
     System.out.println(ls.get(0)); 
     System.out.println(ls);
     ls.ins(0,11.1); ls.ins(1,12.2); ls.ins(2,13.3);
     System.out.println(ls);
     System.out.println(ls.get(0));
     System.out.println(ls.get(1));
     System.out.println(ls.get(100));
     System.out.println(ls); 
     System.out.println(ls.size());
     ls.ins(0,14.4); ls.ins(1,17.7);
     System.out.println(ls);
     System.out.println(ls.get(1));
     System.out.println(ls); 
     System.out.println(ls.get(-100));
     System.out.println(ls);
     return;
   }
   
   public void find (List ls) {
     System.out.println("== Test of find op =========");
     ls.clear();
     System.out.println(ls.find(12.2));
     ls.ins(0,11.1);
     System.out.println(ls.find(11.1));
     System.out.println(ls.find(12.2));
     ls.ins(0,22.2); ls.ins(1,33.3); ls.ins(0,44.4);
     System.out.println(ls.find(33.3));
     System.out.println(ls.find(11.1));
     System.out.println(ls.find(-5.5));
     ls.clear();
     System.out.println(ls.find(11.1));
     return;
   }

   public void isEmpty (List ls) {
      System.out.println("== Test of isEmpty op =======");
      ls.clear();
      System.out.println(ls.isEmpty());
      ls.ins(0,1.1);
      System.out.println(ls.isEmpty());
      ls.ins(0,2.2);
      System.out.println(ls.isEmpty());
      ls.rem(0);
      System.out.println(ls.isEmpty());
      ls.rem(100);
      System.out.println(ls.isEmpty());
      ls.rem(0);
      System.out.println(ls.isEmpty());
      return;
   }
   
   public void contains(List ls) {
      System.out.println("== Test of contains op ======");
      ls.clear();
      return;
   }
   
   public void size (List ls) {
      System.out.println("== Test of size op ==========");
      ls.clear();
      System.out.println(ls.size());
      ls.ins(0,1.1); System.out.println(ls.size());
      ls.ins(0,2.2); System.out.println(ls.size());
      for (int i=2; i<20; i++) { ls.ins(i,i*1.1); }
      System.out.println(ls.size());
      for (int i=0; i<5; i++) { ls.rem(0); }
      System.out.println(ls.size());
      ls.clear();
      System.out.println(ls.size());
      return;
   }
   
   public void clear (List ls) {
      System.out.println("== Test of clear op =========");
      System.out.println(ls.size());
      double n = ls.get(0);
      System.out.println(ls.find(n));
      ls.clear();
      System.out.println(ls.size());
      System.out.println(ls.get(0));
      System.out.println(ls.get(100));
      System.out.println(ls.find(n));
      return;
   }

}
